/**
 * ========================================================
 * SmartSelect - A smart jquery multiple select plugin
 * ========================================================
 *
 * @author     Hong Zhang <smartselect@126.com>
 * @version    1.0.10
 */
;(function($,undefined){'use strict';var pluginPrefix='pa';var pluginName='smartselect';var eventSuffix='.'+pluginPrefix+'.'+pluginName;var fullName=pluginPrefix+'.'+pluginName;function SmartSelect(element,options){this.element=element;this.$element=$(element);this.options=$.extend(true,{},this.defaults,options);this.o=this.options;this.x=this.options.text;this.s=this.options.style;this.e=this.options.event;this.m=this.options.marker;this.t=this.options.template;this.a=this.options.attribute;this.c={};for(var evt in this.callback){if(this.callback.hasOwnProperty(evt)){this.c[evt]=$.merge([],this.callback[evt]);if(this.o.callback[evt])this.addCallback(evt,this.o.callback[evt])}}this._init()};SmartSelect.VERSION='1.0.10';SmartSelect.prototype={defaults:{multiple:true,optimized:false,delayedInit:true,debug:0,debugLevel:5,maxLevels:5,alert:function(text){alert(text)},confirm:function(text){return confirm(text)},closeOnSelect:false,closeOtherSmartSelect:true,defaultValues:null,initialValues:[],keepInSync:true,clickGroupOpen:true,showSelectedInLabel:true,showSelectedCount:2,showSelectedCallback:null,showSelectedSeperator:', ',defaultView:'root+selected',viewAfterCheckAll:true,viewAfterCancel:true,viewAfterAlias:true,closeAfterAlias:true,searchBy:'label',searchCaseInsensitive:true,atLeast:0,atMost:0,mustSelect:[],dataLevelInclusive:false,style:{container:'dropdown',select:'dropdown-toggle btn btn-default',selectIcon:'',selectLabel:'',selectCaret:'caret pull-right',dropdown:'dropdown-menu',toolbarPos:'',toolbar:'btn-group-vertical',button:'btn btn-default',buttonGroup:'btn-group',buttonToggle:'btn btn-default dropdown-toggle',buttonCaret:'caret',buttonDropdown:'dropdown-menu pull-right',liInput:'form-group-sm',inputBox:'form-control',buttonView:'fa fa-fw fa-eye',buttonUnfold:'fa fa-fw fa-folder-o',buttonFoldOpen:'fa fa-fw fa-folder-open-o',buttonCancel:'fa fa-fw fa-undo',buttonCheckAll:'fa fa-fw fa-check',buttonUnCheck:'fa fa-fw fa-times',buttonSearch:'fa fa-fw fa-search',folderOpen:'fa fa-folder-open-o',folderClose:'fa fa-folder-o',divider:'divider',checker:'fa fa-check',dropup:'dropup',buttonAlias:'fa fa-fw fa-star-o',alias:'',aliasIcon:'fa fa-star-o',aliasCaret:'fa fa-times pull-right'},marker:{container:'smartselect',label:'ss-label',caret:'ss-caret',icon:'ss-icon',toolbar:'ss-toolbar',divider:'ss-divider',hide:'ss-hide',open:'open',active:'active',disabled:'disabled',folder:'ss-folder',folderOpen:'ss-open',folderClose:'ss-close',button:'ss-button',group:'ss-group',noGroup:'ss-nogrp',option:'ss-option',checker:'ss-checker',alias:'ss-alias'},template:{container:'<div></div>',select:'<button type="button"><i class="ss-icon"></i><span class="ss-label"></span><i class="ss-caret"></i></button>',dropdown:'<ul></ul>',toolbar:'<li><div role="toolbar"></div></li>',button:'<button type="button"><i class="ss-icon"></i></button>',buttonToggle:'<button type="button"><i class="ss-icon"></i><i class="ss-caret"></i></button>',buttonGroup:'<div></div>',liInput:'<li><div><input type="text" /></div></li>',divider:'<li class="ss-divider"></li>',alias:'<li class="ss-alias"><a><i class="ss-icon"></i><i class="ss-caret"></i><span class="ss-label"></span></a></li>',folder:'<i class="ss-folder ss-close"></i><i class="ss-folder ss-open"></i>'},toolbar:{buttonSearch:true,buttonAlias:true,buttonView:'root+selected',buttonUnfold:true,buttonCancel:true,buttonCheckAll:true,buttonUnCheck:true},event:{click:'click',buttonClick:'click',optionSelect:'click',dropdownToggle:'click'},attribute:{dataView:'data-view',dataMust:'data-must',dataLevel:'data-level',dataUpper:'data-upper',dataAtMost:'data-atmost',dataValue:'data-value',dataDivider:'data-divider',dataAtLeast:'data-atleast',dataExclusive:'data-exclusive',dataInclusive:'data-inclusive',dataLevelInclusive:'data-level-inc',dataGroupExclusive:'data-group-exclusive'},text:{selectLabel:'Smart Select',labelTemplate:'# selected',disabled:'Disabled',aliasPlaceholder:'Save as alias',searchPlaceholder:'Search ...',groupExcludeError:'"data-atleast" can not use with "data-group-exclusive"',callbackError:'unknown callback ',valueSetError:'set value error ',invalidOptionError:'invalid option',badArgumentError:'bad argument ',emptyValuesError:'no option selected',aliasDupError:'alias duplicated',duplicationError:'duplicated option found'},handler:{},callback:{},data:[],aliases:{}},callback:{onPluginLoad:['_fixPluginOptions','_hideOriginalSelect'],onPluginLoaded:['_setDefaultValues','_fixEmptyLogic','_flushSelect','_setSelectLabel','_matchAliasName'],onDropdownShow:['_delayedInit'],onDropdownShown:['_saveOldValues','_updateIcons'],onDropdownHide:[],onDropdownHidden:['_syncSelect'],onOptionChange:[],onOptionChanged:['_flushSelect','_setSelectLabel','_matchAliasName','_closeOnSelect'],onOptionDisable:[],onOptionDisabled:['_fixEmptyLogic'],onOptionSelect:['_atMost'],onOptionSelected:['_fixSelectLogic'],onOptionDeselect:['_fixEmptyLogic'],onOptionDeselected:[]},selectOptions:function(values,clear){this._debug('selectOptions');if(this.isDisabled())return this;if(this._triggerEvent('onOptionChange')){if(clear!==false)this._clearValues();this._setValues(values);if(clear!==false)this._fixEmptyLogic();this._triggerEvent('onOptionChanged')}return this},deselectOptions:function(values){this._debug('deselectOptions');if(this.isDisabled())return this;if(this._triggerEvent('onOptionChange')){this._unSetValues(values);this._triggerEvent('onOptionChanged')}return this},getValues:function(){this._debug('getValues');if(this.isDisabled())return[];var result=this.getSelectedPairs();return result.value},isDisabled:function(){return this.$select.hasClass(this.m.disabled)},disableSelect:function(){this._debug('disableSelect');if(this.isDisabled())return this;this.toggleDropdown(true);this.$select.addClass(this.m.disabled);this._setSelectLabel(this.x.disabled);return this},enableSelect:function(){this._debug('enableSelect');if(this.isDisabled()){this.$select.removeClass(this.m.disabled);this._triggerEvent('onOptionChanged')}return this},disableOptions:function(values){this._debug('disableOptions');if(this.isDisabled())return this;var $todo=$();if(values){for(var i in values){var $li=this._getOptionByValue(values[i]);if(!$li.hasClass(this.m.disabled)){$todo=$todo.add($li)}}}else{$todo=this.$dropdown.find('.'+this.m.option).not('.'+this.m.disabled)}var self=this;$todo.each(function(){var $li=$(this);$li.addClass(self.m.disabled);self._triggerEvent('onOptionDisabled',$li)});this._triggerEvent('onOptionChanged');return this},enableOptions:function(values){this._debug('enableOptions');if(this.isDisabled())return this;var $disabled=$();if(values){for(var i in values){var $li=this._getOptionByValue(values[i]);if($li.hasClass(this.m.disabled)){$disabled=$disabled.add($li)}}}else{$disabled=this.$dropdown.find('.'+this.m.disabled+'.'+this.m.option)}var self=this;$disabled.each(function(){var $li=$(this);$li.removeClass(self.m.disabled);self._triggerEvent('onOptionEnabled',$li)});this._triggerEvent('onOptionChanged');return this},addOption:function(info,after,parent){this._debug('addOption');var self=this;var $opt=this._getOptionByValue(info.value);if($opt.length){$opt.trigger('optionDuplicated'+eventSuffix);return this}var $s,$g,uids=[];if(parent){var $p=this._getOptionByValue(parent);if($p.hasClass(this.m.group)){$g=$p;info.level=1}else{$g=this._getGroup($p);this._getUpperLevels($p,function($x){var level=parseInt($x.attr(self.a.dataLevel));uids[level]=$x.attr('id')});info.level=parseInt($p.attr(self.a.dataLevel))+1;if($p.find('.'+this.m.folder).length===0){$(this.t.folder).insertAfter($p.find('.'+this.m.label));$p.find('.'+this.m.folder+'.'+this.m.folderOpen).addClass(this.s.folderOpen);$p.find('.'+this.m.folder+'.'+this.m.folderClose).addClass(this.s.folderClose)}}if($g.length){uids[0]=$g.attr('id');info.ingroup=true}$s=this.$dropdown.find('.'+$p.attr('id')).last();if($s.length===0)$s=$p}else if(after){$s=this._getOptionByValue(after);$g=this._getGroup($s);this._getUpperLevels($s,function($x){var level=parseInt($x.attr(self.a.dataLevel));uids[level]=$x.attr('id')},false);if($g.length){uids[0]=$g.attr('id');info.ingroup=true}info.level=parseInt($s.attr(self.a.dataLevel));if(this.$dropdown.find('.'+$s.attr('id')).length){$s=this.$dropdown.find('.'+$s.attr('id')).last()}}else{info.level=1}var oid=this._getOid();var html=this._buildOptionHtml(info,oid,uids);$s?$s.after(html):this.$dropdown.append(html);var mapping=this.$dropdown.data('mapping');mapping[info.value]=oid;this.$dropdown.data('mapping',mapping);this._getOptionByValue(info.value).trigger('optionAdded'+eventSuffix);if(this.$dropdown.is(':visible')){this._expandAllLevels();this._updateIcons()}return this},removeOption:function(value){this._debug('removeOption');var $opt=this._getOptionByValue(value);if($opt.length){$opt.remove();var mapping=this.$dropdown.data('mapping');delete mapping[value];this.$dropdown.data('mapping',mapping);this.$element.trigger('optionRemoved'+eventSuffix);this._triggerEvent('onOptionChanged');this._updateIcons()}return this},getGroup:function(name){this._debug('getGroup');if(name.jquery)return name;var $gp=$();var self=this;this.$dropdown.find('.'+this.m.group).each(function(){var label=$(this).find('.'+self.m.label).text();if(label.indexOf(name)>-1){$gp=$(this);return false}});return $gp},getSelectedPairs:function(){this._debug('getSelectedPairs');if(this.isDisabled())return undefined;var result={value:[],label:{}};var self=this;this._getSelectedOptions().each(function(){var $jq=$(this);var val=$jq.attr(self.a.dataValue);result.value[result.value.length]=val;result.label[val]=$jq.find('.'+self.m.label).text()});return result},openDropdown:function(){return this.toggleDropdown(false)},closeDropdown:function(){return this.toggleDropdown(true)},toggleDropdown:function(hideDropdown){this._debug('toggleDropdown');if(this.isDisabled())return this;var hide=this.$container.hasClass(this.m.open)?true:false;if(hideDropdown===false)hide=false;if(hideDropdown===true)hide=true;if(hide){if(this._triggerEvent('onDropdownHide',this.$container)){this.$container.removeClass(this.m.open);this._triggerEvent('onDropdownHidden',this.$container)}}else{if(this._triggerEvent('onDropdownShow',this.$container)){if(this.o.closeOtherSmartSelect){$('.'+this.m.container).filter('.'+this.m.open).not(this.$container).each(function(){var elem=$(this).data(fullName);$(elem).data(fullName).toggleDropdown(true)})}this.$container.addClass(this.m.open);this._triggerEvent('onDropdownShown',this.$container)}}return this},unfoldOption:function(li){this._getOptionByValue(li).find('.'+this.m.folderClose).trigger('click')},toggleOption:function(li,triggerChange,setOption){this._debug('toggleOption');if(this.isDisabled())return this;var $li=li.jquery?li:this._getOptionByValue(li);if($li.length===0){throw new Error(this.x.invalidOptionError);return this}var trigger=triggerChange===false?false:true;if($li.hasClass(this.m.disabled))return this;if(trigger&&!this._triggerEvent('onOptionChange',$li))return this;var active=$li.hasClass(this.m.active);if(setOption===false||active){this._deselectOption(li)}if(setOption===true||!active){this._selectOption(li)}if(trigger&&!this._triggerEvent('onOptionChanged',$li))return this;return this},addCallback:function(event,callback){this._debug('addCallback');if(this.c[event]){if($.isArray(callback)){$.merge(this.c[event],callback)}else{this.c[event].push(callback)}}else{this.o.alert(this.x.callbackError+event)}return this},selectOption:function(li,triggerChange){this._debug('selectOption');return this.toggleOption(li,triggerChange,true)},deselectOption:function(li,triggerChange){this._debug('deselectOption');return this.toggleOption(li,triggerChange,false)},selectAllOptions:function(){this._debug('selectAllOptions');if(this.isDisabled())return this;this._clearValues();var $groups=this._getGroup().not('.'+this.m.disabled);var self=this;$groups.each(function(){var $grp=$(this);self.selectGroupOptions($grp,false)});self.selectGroupOptions();return this},deselectAllOptions:function(){this._debug('deselectAllOptions');if(this.isDisabled())return this;this.$dropdown.find('.'+this.m.active+'.'+this.m.option).not('.'+this.m.disabled).removeClass(this.m.active);this._fireCallbacks('onPluginLoaded',this.$element);return this},selectGroupOptions:function($group,triggerChange){this._debug('selectGroupOptions');if(this.isDisabled())return this;var inc=this._isLevelInclusive($group);if($group){$group=this.getGroup($group);var gid=$group.attr('id');var $opts=this.$dropdown.find('.'+gid+'.'+this.m.option+(inc?'':'.'+this.a.dataLevel+'-1')).not('.'+this.m.disabled)}else{var $opts=this.$dropdown.find('.'+this.m.noGroup+'.'+this.m.option+(inc?'':'.'+this.a.dataLevel+'-1')).not('.'+this.m.disabled)}if(this._isGroupMultiple($group)&&!this._isAtMost()){this._selectOption($opts.first());this._quickSelectOptions($opts,triggerChange)}else{return this._selectMatchedOptions($opts,true,true,triggerChange)}},deselectGroupOptions:function($group,triggerChange){this._debug('deselectGroupOptions');if(this.isDisabled())return this;if($group){$group=this.getGroup($group);var gid=$group.attr('id');var $opts=this.$dropdown.find('.'+this.m.active+'.'+gid).filter('.'+this.m.option).not('.'+this.m.disabled)}else{var $opts=this.$dropdown.find('.'+this.m.active+'.'+this.m.option).filter('.'+this.m.noGroup).not('.'+this.m.disabled)}if($opts.length===0)return this;if(this._isGroupMultiple($group)){this._quickSelectOptions($opts,triggerChange,false)}else{this._selectMatchedOptions($opts,false,true,triggerChange)}return this},addAlias:function(name,value,syncLabel,syncAlias){this._debug('addAlias');if(this.isDisabled())return this;if(typeof name==='string'){if(!$.isArray(value))value=[value];for(var n in this.o.aliases){if(this._arrayEqual(this.o.aliases[n],value)){if(this.o.confirm(this.x.aliasDupError)){this.removeAlias(n,false,false)}else{return this}}if(n===name){if(this.o.confirm(this.x.aliasDupError)){this.removeAlias(n,false,false)}else{return this}}}this.o.aliases[name]=value}else{for(var n in name){this.addAlias(n,name[n],false,false)}this._matchAliasName();return this}if(syncLabel!==false)this._matchAliasName();this._addAliasLine(name);if(syncAlias!==false){this.$element.trigger('aliasChange'+eventSuffix)}return this},removeAlias:function(name,syncLabel,syncAlias){this._debug('removeAlias');if(this.isDisabled())return this;if(typeof name==='string'){delete this.o.aliases[name]}else if($.isArray(name)){for(var i in name){this.removeAlias(name[i],false,false)}this._setSelectLabel();this._matchAliasName();this.$element.trigger('aliasChange'+eventSuffix);return this}if(syncLabel!==false){this._setSelectLabel();this._matchAliasName()}if(this.$buttonAlias){var self=this;this.$buttonAlias.find('.'+this.m.label).each(function(){if($(this).text()===name){$(this).closest('.'+self.m.alias).remove()}})}if(syncAlias!==false){this.$element.trigger('aliasChange'+eventSuffix)}return this},selectAlias:function(name){this.$buttonAlias.find('.'+this.m.label).each(function(){if($(this).text()===name){$(this).click();return false}});return this},syncSelect:function(){this._debug('syncSelect');this._syncSelect();return this},_init:function(){this._debug('_init');if(this._triggerEvent('onPluginLoad')){var data=[];if(this._isSelect){this._extractSelectData(data)}else{data=this.o.data}this._buildPlugin(data);this._triggerEvent('onPluginLoaded')}},_debug:function(str,level){var start=2;try{if(level===undefined){level=0;var func=arguments.callee.caller;while(func){if(++level>20)break;func=func.caller}}}catch(e){level=2}if(this.o.debug&&level<=this.o.debugLevel){console.log(this._stringRepeat('    ',level-start)+level+' '+str+' '+ ++this.o.debug)}},_selectOption:function(li,triggerEvent){this._debug('_selectOption');var $li=li.jquery?li:this._getOptionByValue(li);if($li.length===0)return false;var trigger=triggerEvent===false?false:true;if($li.hasClass(this.m.active))return true;if($li.hasClass(this.m.disabled))return false;if(trigger&&!this._triggerEvent('onOptionSelect',$li))return false;$li.addClass(this.m.active);if(trigger&&!this._triggerEvent('onOptionSelected',$li))return false;return true},_deselectOption:function(li,triggerEvent){this._debug('_deselectOption');var $li=li.jquery?li:this._getOptionByValue(li);if($li.length===0)return false;var trigger=triggerEvent===false?false:true;if(!$li.hasClass(this.m.active))return true;if($li.hasClass(this.m.disabled))return false;if(trigger&&!this._triggerEvent('onOptionDeselect',$li))return false;$li.removeClass(this.m.active);if(trigger&&!this._triggerEvent('onOptionDeselected',$li))return false;return true},_triggerEvent:function(event,$target){this._debug('EVENT '+event);var $tg=$target?$target:this.$element;$tg.trigger(event+eventSuffix);return this._fireCallbacks(event,$tg)},_fireCallbacks:function(event,$tg){var cb=this.c[event];var res=true;for(var i in cb){if(typeof cb[i]==='string'){res=this[cb[i]].call(this,$tg,event)}else{res=cb[i].call(this,$tg,event)}if(res===false)return false}return true},_toggleFolder:function($li){this._debug('_toggleFolder');var self=this;$li.each(function(i,element){var $jq=$(element);var $subs=self.$dropdown.find('.'+$jq.attr('id'));var level=$jq.hasClass(self.m.group)?1:parseInt($jq.attr(self.a.dataLevel))+1;if($jq.hasClass(self.m.open)){$jq.removeClass(self.m.open);$subs.addClass(self.m.hide+'-'+level)}else{$jq.addClass(self.m.open);$subs.removeClass(self.m.hide+'-'+level)}})},_getOptionByValue:function(val){this._debug('_getOptionByValue');if(val.nodeName!==undefined)return $(val);if(val.jquery)return val;val=val.toString();var data=this.$dropdown.data('mapping');if(data[val])return $('#'+data[val]);return $()},_getGroup:function($li){this._debug('_getGroup');var $grp=$();var $groups=this.$dropdown.find('.'+this.m.group);if($li){$groups.each(function(){var $jq=$(this);var gid=$jq.attr('id');if($li.hasClass(gid)){$grp=$jq;return false}});return $grp}else{return $groups}},_selectMatchedOptions:function($jq,select,triggerEvent,triggerChange){this._debug('_selectMatchedOptions');var trigger=triggerChange===false?false:true;if(trigger&&!this._triggerEvent('onOptionChange'))return this;var self=this;$jq.each(function(){var $ob=$(this);if(select===false){self._deselectOption($ob,triggerEvent)}else{self._selectOption($ob,triggerEvent)}});if(trigger)this._triggerEvent('onOptionChanged');return this},_quickSelectOptions:function($jq,triggerChange,select){this._debug('_quickSelectOptions');var trigger=triggerChange===false?false:true;if(trigger&&!this._triggerEvent('onOptionChange'))return this;if(select===false){$jq.removeClass(this.m.active)}else{$jq.addClass(this.m.active)}if(trigger)this._triggerEvent('onOptionChanged');return this},_matchAliasName:function(){this._debug('_matchAliasName');if(this.o.showSelectedInLabel){var v=this._getSelectedValues();var a=this.o.aliases;if(v.length){for(var n in a){this._toString(a[n]);if(a.hasOwnProperty(n)&&this._arrayEqual(v,a[n])){this.$select.find('.'+this.m.label).html(n);break}}}}return true},_addAliasLine:function(name){if(this.$buttonAlias){this._debug('_addAliasLine');var self=this;var $ul=this.$buttonAlias.find('ul');var $li=$(this.t.alias).appendTo($ul);$li.find('.'+this.m.label).addClass(this.s.alias).text(name);$li.find('.'+this.m.icon).addClass(this.s.aliasIcon);$li.find('.'+this.m.caret).addClass(this.s.aliasCaret);$ul.find('.'+this.m.alias).off().on(this.e.click,'.'+this.m.label,function(e){var n=$(e.target).closest('.'+self.m.alias).find('.'+self.m.label).text();if(self.o.aliases[n].length>30&&self.o.optimized){self._quickSelectValues(self.o.aliases[n])}else{self.selectOptions(self.o.aliases[n])}e.stopPropagation();e.preventDefault();self.$buttonAlias.removeClass(self.m.open);if(self.o.viewAfterAlias&&self.$buttonView){self.$buttonView.trigger('click')}if(self.o.closeAfterAlias){self.$select.trigger('click')}}).on(this.e.click,'.'+this.m.caret,function(e){var n=$(e.target).closest('.'+self.m.alias).find('.'+self.m.label).text();self.removeAlias(n);e.stopPropagation();e.preventDefault()})}},_updateIcons:function(){this._debug('_updateIcons');this.$dropdown.find('.'+this.m.folder).filter(':visible').each($.proxy(function(i,element){var $jq=$(element);var $li=$jq.closest('li');var id=$li.attr('id');var lev=parseInt($li.attr(this.a.dataLevel))+1;var $sub=this.$dropdown.find('.'+id+'.'+this.a.dataLevel+'-'+lev);if($sub.filter(':hidden').length){$li.removeClass(this.m.open)}else if($sub.length){$li.addClass(this.m.open)}else{$li.find('.'+this.m.folder).remove()}},this));if(this.$buttonUnfold){if(this.$dropdown.find('.'+this.m.folder+'.'+this.m.folderOpen).filter(':hidden').length){this.$buttonUnfold.find('.'+this.m.icon).removeClass(this.s.buttonFoldOpen).addClass(this.s.buttonUnfold)}else{this.$buttonUnfold.find('.'+this.m.icon).removeClass(this.s.buttonUnfold).addClass(this.s.buttonFoldOpen)}}return this},_extractSelectData:function(data,$element){var a=this.a;var self=this;if($element===undefined){this._debug('_extractSelectData');var atLeast=this.$element.attr(a.dataAtLeast);if(atLeast!==undefined){this.o.atLeast=parseInt(atLeast)}var atMost=this.$element.attr(a.dataAtMost);if(atMost!==undefined){this.o.atMost=parseInt(atMost)}}($element?$element:this.$element).children().each(function(i,node){var $node=$(node),row={};if(node.nodeName==='OPTION'){if($node.attr(a.dataDivider)!==undefined){row[a.dataDivider]=true;data[data.length]=row;return true}row.value=$node.val();row.label=$node.text();row.ingroup=$element!==undefined;if($node.attr('selected')!==undefined){var len=self.o.initialValues.length;self.o.initialValues[len]=row.value}row.level=parseInt($node.attr(a.dataLevel)?$node.attr(a.dataLevel):1);var view=$node.attr(a.dataView);if(view!==undefined){row[a.dataView]=row.level+(view.length?parseInt(view):1)}if($node.attr(a.dataMust)!==undefined){row[a.dataMust]=true}var inc=$node.attr(a.dataInclusive);if(inc!==undefined)row[a.dataInclusive]=inc.length?inc:'_';data[data.length]=row}else{row[a.dataGroup]=true;row.label=$node.attr('label');var exc=$node.attr(a.dataGroupExclusive);if(exc!==undefined){row[a.dataGroupExclusive]=exc.length?exc:'_'}if($node.attr(a.dataExclusive)!==undefined||!self._isMultiple){row[a.dataExclusive]=true}if($node.attr(a.dataLevelInclusive)!==undefined){row[a.dataLevelInclusive]=true}if($node.attr(a.dataAtLeast)!==undefined){if(row[a.dataGroupExclusive]){this.o.alert(self.o.text.groupExcludeError)}else{var l=$node.attr(a.dataAtLeast);row[a.dataAtLeast]=l.length?parseInt(l):1}}if($node.attr(a.dataAtMost)!==undefined){row[a.dataAtMost]=parseInt($node.attr(a.dataAtMost))}var view=$node.attr(a.dataView);if(view!==undefined){row[a.dataView]=view.length?parseInt(view):1}data[data.length]=row;self._extractSelectData(data,$node)}})},_buildPlugin:function(data){this._debug('_buildPlugin');this._buildContainer()._buildSelect()._buildDropdown()._buildOption(data);if(this.o.delayedInit){this._delayed=false}else{this._delayedInit()}return this},_buildContainer:function(){this._debug('_buildContainer');this.$container=$(this.t.container).addClass(this.m.container+' '+this.s.container).insertAfter(this.$element).data(fullName,this.element);return this},_buildSelect:function(){this._debug('_buildSelect');this.$select=$(this.t.select).addClass(this.s.select).appendTo(this.$container);this.$select.find('.'+this.m.icon).addClass(this.s.selectIcon);this.$select.find('.'+this.m.label).addClass(this.s.selectLabel).html(this.x.selectLabel);this.$select.find('.'+this.m.caret).addClass(this.s.selectCaret);return this},_buildDropdown:function(){this._debug('_buildDropdown');this._theId=this._uniqueId();this.$dropdown=$(this.t.dropdown).addClass(this.s.dropdown).appendTo(this.$container).attr('id',this._theId);this.$select.off().not('.'+this.m.disabled).on(this.e.click,$.proxy(function(e){this.toggleDropdown()},this));return this},_buildToolbar:function(){this._debug('_buildToolbar');var t=this.o.toolbar;if(t){this.$toolbar=$(this.t.toolbar).addClass(this.m.toolbar).addClass(this.s.toolbarPos).prependTo(this.$dropdown).children().addClass(this.s.toolbar);for(var btn in t){if(t.hasOwnProperty(btn)&&t[btn]&&this['_'+btn]){this['_'+btn]()}}}return this},_buildToolbtn:function(iconClass,toggle){var $btn;if(toggle){$btn=$(this.t.buttonToggle).addClass(this.s.buttonToggle)}else{$btn=$(this.t.button).addClass(this.s.button).addClass(this.m.button)}$btn.children('.'+this.m.icon).addClass(iconClass);if(toggle){$btn.children('.'+this.m.caret).addClass(this.s.buttonCaret)}return $btn},_buttonView:function(){this._debug('_buttonView');var v=typeof this.o.toolbar.buttonView==='string'?this.o.toolbar.buttonView:'root+selected';this.$buttonView=this._buildToolbtn(this.s.buttonView).appendTo(this.$toolbar).on(this.e.buttonClick,$.proxy(function(){this._setDefaultView(v,false);this._updateIcons()},this))},_buttonUnfold:function(){this._debug('_buttonUnfold');this.$buttonUnfold=this._buildToolbtn(this.s.buttonUnfold).appendTo(this.$toolbar).on(this.e.buttonClick,$.proxy(function(){this._expandAllLevels();this._updateIcons()},this))},_buttonCheckAll:function(){this._debug('_buttonCheckAll');if(this._isMultiple){this.$buttonCheckAll=this._buildToolbtn(this.s.buttonCheckAll).appendTo(this.$toolbar).on(this.e.buttonClick,$.proxy(function(){this.selectAllOptions();if(this.o.viewAfterCheckAll&&this.$buttonView){this.$buttonView.trigger('click')}else{this._updateIcons()}},this))}},_buttonUnCheck:function(){this._debug('_buttonUnCheck');if(this._isMultiple){this.$buttonUnCheck=this._buildToolbtn(this.s.buttonUnCheck).appendTo(this.$toolbar).on(this.e.buttonClick,$.proxy(function(){this.deselectAllOptions();this._updateIcons()},this))}},_buttonCancel:function(){this._debug('_buttonCancel');this.$buttonCancel=this._buildToolbtn(this.s.buttonCancel).appendTo(this.$toolbar).on(this.e.buttonClick,$.proxy(function(){if(this._isChanged()){this.selectOptions(this.$buttonCancel.data('cancel'))}if(this.o.viewAfterCancel&&this.$buttonView){this.$buttonView.trigger('click')}else{this._updateIcons()}},this))},_buttonAlias:function(){this._debug('_buttonAlias');var self=this;this.$buttonAlias=$(this.t.buttonGroup).addClass(this.s.buttonGroup+' '+this.m.button).appendTo(this.$toolbar).append(this._buildToolbtn(this.s.buttonAlias,true)).on(this.e.buttonClick,'button',function(){if(!self.$buttonAlias.hasClass(self.m.open)){self.$buttonAlias.addClass(self.m.open);self.$save.focus()}else{self.$buttonAlias.removeClass(self.m.open)}});var $dropdown=$(this.t.dropdown).addClass(this.s.buttonDropdown);this.$buttonAlias.append($dropdown);var $input=$(this.t.liInput).addClass(this.s.liInput).appendTo($dropdown);this.$save=$input.find('input').addClass(this.s.inputBox).attr('placeholder',this.x.aliasPlaceholder).on('keydown',function(e){if(e.which===13&&self.$save.val()!==''){var vals=self._getSelectedValues();if(vals.length){self.addAlias(self.$save.val(),self._getSelectedValues());self.$save.val('');self.$buttonAlias.removeClass(self.m.open)}else{self.o.alert(self.x.emptyValuesError)}}});for(var n in this.o.aliases){this._addAliasLine(n)}},_buttonSearch:function(){this._debug('buttonSearch');var self=this;this.$buttonSearch=$(this.t.buttonGroup).addClass(this.s.buttonGroup+' '+this.s.dropup+' '+this.m.button).appendTo(this.$toolbar).append(this._buildToolbtn(this.s.buttonSearch,true)).on(this.e.buttonClick,'button',function(e){self.$buttonSearch.toggleClass(self.m.open).siblings().removeClass(self.m.open);self.$buttonSearch.find('input').focus()});var $dropdown=$(this.t.dropdown).addClass(this.s.buttonDropdown);this.$buttonSearch.append($dropdown);var $input=$(this.t.liInput).addClass(this.s.liInput).appendTo($dropdown);var self=this;$input.find('input').addClass(this.s.inputBox).attr('placeholder',this.x.searchPlaceholder).on('focus keyup',function(e){if(e.which===13)return false;var str=$(this).val();self._searchOptions(str)})},_buildOption:function(data){this._debug('_buildOption');var mapping={};var html='',gid='',oid='';var uids=[''];var len=data.length;for(var i=0;i<len;++i){var row=data[i];if(row[this.a.dataGroup]){gid=this._getOid();html+=this._buildOptGroupHtml(row,gid);uids=[gid];if(row[this.a.dataAtLeast])this._oneInGroup=true}else if(row[this.a.dataDivider]){html+=this._buildDividerHtml()}else{oid=this._getOid();mapping[row.value]=oid;var next=data[i+1];if(next&&next.level&&next.level>row.level)row.children=true;uids[parseInt(row.level)]=oid;html+=this._buildOptionHtml(row,oid,uids)}}this.$dropdown.empty().data('mapping',mapping).append(html);return this},_quickSelectValues:function(values,clear){this._debug('_quickSelectValues');if(this._triggerEvent('onOptionChange')){if(clear!==false)this._clearValues();var data=this.$dropdown.data('mapping');var val;for(var i in values){val=values[i];if(data[val])$('#'+data[val]).addClass(this.m.active)}if(clear!==false)this._fixEmptyLogic();this._triggerEvent('onOptionChanged')}return this},_isChanged:function(){this._debug('_isChanged');if(this.$buttonCancel){var old=this.$buttonCancel.data('cancel');var val=this._getSelectedValues();if(this._arrayEqual(old,val))return false}return true},_getOid:function(){if(this._ocnt===undefined)this._ocnt=0;return this._theId+'-opt'+ ++this._ocnt},_buildDividerHtml:function(){return this.t.divider},_buildOptGroupHtml:function(row,gid){var html='<li id="'+gid+'" class="'+this.m.group+' '+this.m.hide+' '+(row[this.a.dataExclusive]?this.a.dataExclusive+' ':'')+(row[this.a.dataLevelInclusive]?this.a.dataLevelInclusive+' ':'')+(row[this.a.dataView]?this.a.dataView+' ':'')+'" '+this.a.dataLevel+'="0" '+(row[this.a.dataAtMost]?this.a.dataAtMost+'="'+row[this.a.dataAtMost]+'" ':'')+(row[this.a.dataAtLeast]?this.a.dataAtLeast+'="'+row[this.a.dataAtLeast]+'" ':'')+(row[this.a.dataView]?this.a.dataView+'="'+row[this.a.dataView]+'" ':'')+(row[this.a.dataGroupExclusive]?this.a.dataGroupExclusive+'="'+row[this.a.dataGroupExclusive]+'" ':'')+'><a><span class="'+this.m.label+'">'+row.label+'</span>'+this.t.folder+'</a></li>';return html},_buildOptionHtml:function(row,oid,uids){this._debug('_buildOptionHtml');var myuids=[];for(var i=row.ingroup?0:1;i<row.level;i++){myuids[i]=uids[i]}var html='<li id="'+oid+'" '+'class="'+this.m.option+' '+(row.ingroup?'':this.m.noGroup+' ')+this.m.hide+' '+(row.ingroup?this.m.hide+'-'+row.level+' ':'')+myuids.join(' ')+' '+(row[this.a.dataView]?this.a.dataView+' ':'')+(row[this.a.dataMust]?this.a.dataMust+' ':'')+this.a.dataLevel+'-'+row.level+'" '+(row.level>1?this.a.dataUpper+'="'+myuids[row.level-1]+'" ':'')+(row[this.a.dataInclusive]?this.a.dataInclusive+'="'+row[this.a.dataInclusive]+'" ':'')+(row[this.a.dataView]?this.a.dataView+'="'+row[this.a.dataView]+'" ':'')+this.a.dataValue+'="'+row.value+'" '+this.a.dataLevel+'="'+row.level+'" '+'><a><i class="'+this.m.checker+' '+this.s.checker+'"></i><span class="'+this.m.label+'">'+row.label+'</span>'+(row.children?this.t.folder:'')+'</a></li>';return html},_closeToolbar:function(){if(this.$toolbar){this._debug('_closeToolbar');this.$toolbar.removeClass(this.m.open).find('.'+this.m.open).removeClass(this.m.open)}},_bindEvents:function(){this._debug('_bindEvents');var self=this;var m=this.m;this.$dropdown.off().on(this.e.click,function(){self._closeToolbar()}).on(this.e.click,'.'+m.toolbar,function(e){e.stopPropagation();e.preventDefault();return false}).on(this.e.click,'.'+m.button,function(e){$(e.target).closest('.'+self.m.button).siblings().removeClass(m.open)}).on(this.e.click,'.'+m.folder,function(e){self._toggleFolder($(e.target).closest('li'));self._closeToolbar();self._updateIcons();return false}).on(this.e.click,'.'+m.group,function(e){if(self.o.clickGroupOpen){self._toggleFolder($(e.target).closest('.'+m.group));self._updateIcons()}}).on(this.e.click,'.'+m.option,function(e){self.toggleOption($(this))});return this},_expandAllLevels:function(forceCollapse,viewGroup){this._debug('_expandAllLevels');var self=this;if(forceCollapse){this.$dropdown.find('.'+this.m.option).each(function(i,element){var $li=$(element);$li.addClass(self.m.hide+'-'+$li.attr(self.a.dataLevel))});if(viewGroup===false){this.$dropdown.find('.'+this.m.group).addClass(self.m.hide+'-0')}else{this.$dropdown.find('.'+this.m.group).removeClass(self.m.hide+'-0')}}else{this.$dropdown.find('.'+this.m.option).removeClass(this._allHideClasses);this.$dropdown.find('.'+this.m.group).removeClass(this.m.hide+'-0')}},_getUpperLevels:function($li,callback,andSelf){this._debug('_getUpperLevels');var level=parseInt($li.attr(this.a.dataLevel));if(andSelf!==false)callback($li);if(level>1){var $up=$('#'+$li.attr(this.a.dataUpper));if(andSelf===false)callback($up);this._getUpperLevels($up,callback)}},_getOptionValue:function($li){this._debug('_getOptionValue');return $li.attr(this.a.dataValue)},_getSelectedValues:function(){this._debug('_getSelectedValues');var result=[];var self=this;this._getSelectedOptions().each(function(){result[result.length]=$(this).attr(self.a.dataValue)});return result},_getSelectedLabels:function(){this._debug('_getSelectedLabels');var result=[];var self=this;this._getSelectedOptions().each(function(){result[result.length]=$(this).find('.'+self.m.label).text()});return result},_getSelectedOptions:function(skipDisabled){this._debug('_getSelectedOptions');var $res=this.$dropdown.find('.'+this.m.active+'.'+this.m.option);if(skipDisabled===false){return $res}else{return $res.not('.'+this.m.disabled)}},_setValues:function(values){this._debug('_setValues');this._toString(values);for(var i in values){if(!this._selectOption(values[i])){this.o.alert(this.x.valueSetError+values[i])}}return this},_unSetValues:function(values){this._debug('_unSetValues');this._toString(values);for(var i in values){if(!this._deselectOption(values[i])){this.o.alert(this.x.valueSetError+values[i])}}return this},_clearValues:function(){this._debug('_clearValues');this.$dropdown.find('.'+this.m.active+'.'+this.m.option).not('.'+this.m.disabled).removeClass(this.m.active);return this},_searchOptions:function(str){var self=this;str=str.replace(/(^\s*)|(\s*$)/g,'');if(str===''){this._expandAllLevels()}else{this._expandAllLevels(true,false);this.$dropdown.find('.'+this.m.option).not('.'+this.m.disabled).each(function(){var $opt=$(this);var value=$opt.attr(self.a.dataValue);var label=$opt.find('.'+self.m.label).text();var toSrch=label;if(self.o.searchBy==='value'){toSrch=value}else if(self.o.searchBy==='both'){toSrch=label+' '+value}if(self.o.searchCaseInsensitive){str=str.toLowerCase();toSrch=toSrch.toLowerCase()}if(toSrch.indexOf(str)>-1){self._getUpperLevels($opt,function($x){$x.removeClass(self._allHideClasses)});self._getGroup($opt).removeClass(self.m.hide+'-0')}});this._updateIcons()}},_uniqueId:function(){this._debug('_uniqueId');return's'+(Math.random()+1).toString(36).slice(-5)},_hasClasses:function($jq,c){this._debug('_hasClasses');var a=c.split(' ');for(var i=0,l=a.length;i<l;i++){if(!$jq.hasClass(a[i]))return false}return true},_toString:function(a){this._debug('_toString');for(var i in a){a[i]=a[i].toString()}},_isPeer:function($one,$two){this._debug('_isPeer');return $one.attr(this.a.dataUpper)===$two.attr(this.a.dataUpper)},_isDataInclusive:function($one,$two){this._debug('_isDataInclusive');if(this._isPeer($one,$two)){var o=$one.attr(this.a.dataInclusive);var t=$two.attr(this.a.dataInclusive);return this._charOverlap(o,t)}return false},_isGroupExclusive:function($one,$two){this._debug('_isGroupExclusive');var o=$one?$one.attr(this.a.dataGroupExclusive):undefined;var t=$two?$two.attr(this.a.dataGroupExclusive):undefined;return!this._charOverlap(o===undefined?'.':o,t===undefined?'.':t)},_isGroupMultiple:function($group){this._debug('_isGroupMultiple');if($group&&$group.length){return!$group.hasClass(this.a.dataExclusive)}else{return!(this._isMultiple&&this._isDataExclusive)}},_isLevelInclusive:function($group){this._debug('_isLevelInclusive');if($group&&$group.length){return $group.hasClass(this.a.dataLevelInclusive)||this.o.dataLevelInclusive}else{return this.o.dataLevelInclusive}},_charOverlap:function(A,B){this._debug('_charOverlap');var a=A?A.split(' '):[];var b=B?B.split(' '):[];var match=a.filter(function(n){return b.indexOf(n)!==-1});return match.length?true:false},_arrayEqual:function(a,b){this._debug('_arrayEqual');if(a.length!==b.length||a.filter(function(n){return b.indexOf(n)===-1}).length+b.filter(function(n){return a.indexOf(n)===-1}).length>0)return false;return true},_stringRepeat:function(str,num){var tmp='';for(var i=0;i<num;i++)tmp+=str;return tmp},_fixPluginOptions:function(){this._debug('_fixPluginOptions');this._isSelect=this.element.nodeName==='SELECT';this._isMultiple=this.o.multiple?true:false;if(this._isSelect&&this.$element.attr('multiple')===undefined){this._isMultiple=false}if(this._isSelect&&this.$element.attr(this.a.dataExclusive)!==undefined){this._isDataExclusive=true}if(!this._isMultiple)this.o.closeOnSelect=true;if(this.o.optimized){this.o.delayedInit=true;this.o.keepInSync=false;this.o.debug=0}if(this.o.defaultValues!==null&&!this.o.atLeast){this.o.atLeast=1}for(var i in this.o.handler){if(this.o.handler.hasOwnProperty(i)){this.$element.on(i+eventSuffix,this.o.handler[i])}}this._allHideClasses='';for(var i=1;i<=this.o.maxLevels;i++){this._allHideClasses+=this.m.hide+'-'+i+' '}return true},_hideOriginalSelect:function(){this._debug('_hideOriginalSelect');if(this._isSelect)this.$element.hide();return true},_setDefaultValues:function(){this._debug('_setDefaultValues');this._clearValues();if(this.o.initialValues.length){this._setValues(this.o.initialValues);this.o.initialValues.length=0}else if(this.o.defaultValues!==null){this._setValues(this.o.defaultValues)}return true},_fixEmptyLogic:function($target,event){this._debug('_fixEmptyLogic');if(this._mustSelect($target,event)&&this._atLeastInGroup($target,event)&&this._atLeast($target,event)){return true}return false},_atLeast:function($target,event){this._debug('_atLeast');if(!this.o.atLeast)return true;var $selected=this._getSelectedOptions();var req=this.o.atLeast;if(event==='onOptionDeselect'){if($selected.not($target).length+1>req)return true;if(req===1&&this.o.defaultValues!==null){this._setValues(this.o.defaultValues);if($.inArray(this._getOptionValue($target),this.o.defaultValues)===-1)return true}this.$element.trigger('atLeast'+eventSuffix);return false}else if(event==='onOptionDisabled'){if($selected.length>=req)return true;if(req===1&&this.o.defaultValues!==null){this._setValues(this.o.defaultValues)}$selected=this._getSelectedOptions();if($selected.length>=req)return true;this._selectMatchedOptions(this.$dropdown.find('.'+this.m.option).not('.'+this.m.disabled).not('.'+this.m.active).slice(0,req-$selected.length),true,true,false);return true}else{if($selected.length>=req)return true;if(this.o.defaultValues!==null){this._setValues(this.o.defaultValues);$selected=this._getSelectedOptions()}if($selected.length<req){this._selectMatchedOptions(this.$dropdown.find('.'+this.m.option).not('.'+this.m.disabled).not('.'+this.m.active).slice(0,req-$selected.length),true,true,false)}}return true},_mustSelect:function($target,event){this._debug('_mustSelect');if(this.o.mustSelect.length>0){var ms=this.o.mustSelect;for(var i in ms){var $x=this._getOptionByValue(ms[i]);$x.addClass(this.a.dataMust)}this.o.mustSelect.length=0}var $must=this.$dropdown.find('.'+this.a.dataMust).not('.'+this.m.disabled);if($must.length===0)return true;if(event==='onOptionDeselect'){if($must.filter($target).length){this.$element.trigger('mustSelect'+eventSuffix);return false}return true}else if(event==='onPluginLoaded'){this._selectMatchedOptions($must,true,true,false)}return true},_atMost:function($target,event){this._debug('_atMost');if(!this._isAtMost())return true;var $group=this._getGroup($target);if($group.length){if($group.is('['+this.a.dataAtMost+']')){var most=parseInt($group.attr(this.a.dataAtMost));if(this.$dropdown.find('.'+this.m.active+'.'+$group.attr('id')).not('.'+this.m.disabled).length===most){this.$element.trigger('atMost'+eventSuffix);return false}}}if(!this.o.atMost)return true;var $selected=this._getSelectedOptions();if($selected.length<this.o.atMost)return true;this.$element.trigger('atMost'+eventSuffix);return false},_isAtMost:function(){if(this._atmost!==undefined)return this._atmost;if(this.o.atMost){this._atmost=true;return this._atmost}if(this.$dropdown.find('.'+this.m.group).not('.'+this.m.disabled).filter('['+this.a.dataAtMost+']').length){this._atmost=true;return this._atmost}this._atmost=false;return this._atmost},_atLeastInGroup:function($target,event){this._debug('_atLeastInGroup');if(!this._oneInGroup)return true;if(event==='onOptionDeselect'){var $group=this._getGroup($target);if($group.length===0)return true;if(!$group.is('['+this.a.dataAtLeast+']'))return true;var least=parseInt($group.attr(this.a.dataAtLeast));if(this._getSelectedOptions().filter('.'+$group.attr('id')).length>least)return true;this.$element.trigger('atLeast'+eventSuffix);return false}else if(event==='onOptionDisabled'){var $group=this._getGroup($target);if($group.length===0)return true;if(!$group.is('['+this.a.dataAtLeast+']'))return true;var gid=$group.attr('id');var least=parseInt($group.attr(this.a.dataAtLeast));var done=this._getSelectedOptions().filter('.'+gid).length;if(done>=least)return true;this._selectMatchedOptions(this.$dropdown.find('.'+gid).not('.'+this.m.disabled).not('.'+this.m.active).slice(0,least-done),true,true,false);return true}else{var self=this;this._getGroup().filter('['+this.a.dataAtLeast+']').each(function(){var least=parseInt($(this).attr(self.a.dataAtLeast));self._selectMatchedOptions(self.$dropdown.children('.'+$(this).attr('id')).not('.'+self.m.disabled).slice(0,least),true,true,false)})}return true},_fixSelectLogic:function($target){this._debug('_fixSelectLogic');var $other=this._getSelectedOptions().not($target);if($other.length===0)return true;var self=this;if(this._isMultiple===false){$other.each(function(){self._deselectOption(this)});return true}var $group=this._getGroup($target);var level=parseInt($target.attr(this.a.dataLevel));var $grps=this.$dropdown.find('.'+this.m.group).not('.'+this.m.disabled).not($group);var glist=[];$grps.each(function(){glist[glist.length]=$(this)});for(var i in glist){var $grp=glist[i];if(self._isGroupExclusive($group,$grp)){self.deselectGroupOptions($grp,false)}}if($group.length&&self._isGroupExclusive($group)){self.deselectGroupOptions(undefined,false)}if(!this._isGroupMultiple($group)){var $sgOpts=this.$dropdown.find('.'+this.m.active+'.'+this.m.option).filter('.'+($group.length?$group.attr('id'):this.m.noGroup)).not('.'+this.m.disabled).not($target);$sgOpts.each(function(){var $li=$(this);if(!self._isDataInclusive($target,$li)){self._deselectOption($li)}})}if(!this._isLevelInclusive($group)){this.$dropdown.find('.'+$target.attr('id')+'.'+this.m.active).not('.'+this.m.disabled).removeClass(this.m.active);var $sgOpts=this.$dropdown.find('.'+this.m.active+'.'+this.m.option).filter('.'+($group.length?$group.attr('id'):this.m.noGroup)).not('.'+this.m.disabled).not($target);if(level>1&&$sgOpts.length){var upper=$target.attr(this.a.dataUpper);var $peers=this.$dropdown.find('.'+upper).filter('.'+this.a.dataLevel+'-'+level).not('.'+this.m.disabled);var p=$peers.not('.'+this.m.active).length;if($peers.length===1||p>0){this._getUpperLevels($target,function($x){if($x.hasClass(self.m.active)){self._deselectOption($x)}},false)}else if(p===0){this._selectOption($('#'+upper))}}}return true},_setSelectLabel:function(txt){if(this.o.showSelectedInLabel){this._debug('_setSelectLabel');if(typeof txt==='string'){var text=txt}else{var text=this.x.selectLabel;var labels=this._getSelectedLabels();if(labels.length){if(this.o.showSelectedCallback){text=this.o.showSelectedCallback.call(this,labels)}else{if(labels.length<=this.o.showSelectedCount){text=labels.join(this.o.showSelectedSeperator)}else{text=this.x.labelTemplate.replace('#',labels.length)}}}}this.$select.find('.'+this.m.label).html(text)}return true},_saveOldValues:function(){this._debug('_saveOldValues');if(this.$buttonCancel){this.$buttonCancel.data('cancel',this._getSelectedValues())}return true},_delayedInit:function(){if(this._delayed===true)return true;this._debug('_delayedInit');this.$dropdown.find('.'+this.m.folder+'.'+this.m.folderOpen).addClass(this.s.folderOpen);this.$dropdown.find('.'+this.m.folder+'.'+this.m.folderClose).addClass(this.s.folderClose);this.$dropdown.find('.'+this.m.divider).addClass(this.s.divider);this._buildToolbar()._bindEvents();this._setDefaultView();this._delayed=true;return true},_setDefaultView:function(view,dataView){var self=this;var views=(view?view:this.o.defaultView).split('+');if($.inArray('expand',views)>-1){this._expandAllLevels();return true}this._expandAllLevels(true);if($.inArray('root',views)>-1){this.$dropdown.find('.'+this.m.noGroup).removeClass(this._allHideClasses)}if($.inArray('level1',views)>-1){this.$dropdown.find('.'+this.m.option).filter('['+this.a.dataLevel+'=1]').removeClass(this._allHideClasses)}if($.inArray('level2',views)>-1){this.$dropdown.find('.'+this.m.option).filter('['+this.a.dataLevel+'=1]').removeClass(this._allHideClasses);this.$dropdown.find('.'+this.m.option).filter('['+this.a.dataLevel+'=2]').removeClass(this._allHideClasses)}if($.inArray('selected',views)>-1){this.$dropdown.find('.'+this.m.active+'.'+this.m.option).not('.'+this.m.disabled).each(function(i,li){var $li=$(li);self._getUpperLevels($li,function($x){$x.removeClass(self._allHideClasses)})})}if(dataView!==false){this.$dropdown.find('.'+this.a.dataView).not('.'+this.m.disabled).each(function(i,li){var $li=$(li);self._getUpperLevels($li,function($x){$x.removeClass(self._allHideClasses)});var id=$li.attr('id');var v=parseInt($li.attr(self.a.dataView));v=v<4?v:1;for(var i=1;i<=v;++i){self.$dropdown.find('.'+id+'.'+self.a.dataLevel+'-'+i).removeClass(self._allHideClasses)}})}return true},_closeOnSelect:function(){if(this.o.closeOnSelect){this.$select.trigger('click')}},_syncSelect:function(){if(this._isSelect){this._debug('_syncSelect');var old=this.o.keepInSync;this.o.keepInSync=true;this._flushSelect();this.o.keepInSync=old}return true},_flushSelect:function(){if(this._isSelect&&this.o.keepInSync){this._debug('_flushSelect');var vals=this._getSelectedValues();this.$element.find('option:selected').prop('selected',false);if(vals.length){this.$element.find('option').each(function(){var v=$(this).val();if($.inArray(v,vals)>-1){$(this).prop('selected',true)}})}}return true}};function Plugin(options,extras){return this.each(function(){var $this=$(this);if(options==='destroy'){$this.data(fullName,false);return}var data=$this.data(fullName);if(!data){$this.data(fullName,(data=new SmartSelect(this,options)));return}if(typeof options==='string')data[options].apply($this,extras)})};var old=$.fn[pluginName];$.fn[pluginName]=Plugin;$.fn[pluginName].Constructor=SmartSelect;$.fn['get'+pluginName]=function(){return this.first().data(fullName)};$.fn[pluginName].noConflict=function(){$.fn[pluginName]=old;return this}})(window.jQuery);
